VERSION 5.00
Begin VB.Form Frm2650 
   BorderStyle     =   1  'Fixed Single
   ClientHeight    =   3615
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   1635
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MDIChild        =   -1  'True
   MinButton       =   0   'False
   ScaleHeight     =   3615
   ScaleWidth      =   1635
   ShowInTaskbar   =   0   'False
   Visible         =   0   'False
   Begin VB.CommandButton BtnDemo 
      Caption         =   "&Demo"
      Height          =   375
      Left            =   120
      Style           =   1  'Graphical
      TabIndex        =   10
      Top             =   3120
      Width           =   675
   End
   Begin VB.CommandButton BtnReset 
      Caption         =   "&Reset"
      Height          =   375
      Left            =   840
      Style           =   1  'Graphical
      TabIndex        =   9
      Top             =   3120
      Width           =   675
   End
   Begin VB.Frame Frame 
      Caption         =   "Relay Control"
      Height          =   2475
      Left            =   180
      TabIndex        =   0
      Top             =   180
      Width           =   1275
      Begin VB.CheckBox ChkRlyCmd 
         Caption         =   "CH7"
         Height          =   195
         Index           =   7
         Left            =   300
         TabIndex        =   8
         Top             =   2100
         Width           =   735
      End
      Begin VB.CheckBox ChkRlyCmd 
         Caption         =   "CH6"
         Height          =   195
         Index           =   6
         Left            =   300
         TabIndex        =   7
         Top             =   1860
         Width           =   735
      End
      Begin VB.CheckBox ChkRlyCmd 
         Caption         =   "CH5"
         Height          =   195
         Index           =   5
         Left            =   300
         TabIndex        =   6
         Top             =   1620
         Width           =   735
      End
      Begin VB.CheckBox ChkRlyCmd 
         Caption         =   "CH4"
         Height          =   195
         Index           =   4
         Left            =   300
         TabIndex        =   5
         Top             =   1380
         Width           =   735
      End
      Begin VB.CheckBox ChkRlyCmd 
         Caption         =   "CH3"
         Height          =   195
         Index           =   3
         Left            =   300
         TabIndex        =   4
         Top             =   1140
         Width           =   735
      End
      Begin VB.CheckBox ChkRlyCmd 
         Caption         =   "CH2"
         Height          =   195
         Index           =   2
         Left            =   300
         TabIndex        =   3
         Top             =   900
         Width           =   735
      End
      Begin VB.CheckBox ChkRlyCmd 
         Caption         =   "CH1"
         Height          =   195
         Index           =   1
         Left            =   300
         TabIndex        =   2
         Top             =   660
         Width           =   735
      End
      Begin VB.CheckBox ChkRlyCmd 
         Caption         =   "CH0"
         Height          =   195
         Index           =   0
         Left            =   300
         TabIndex        =   1
         Top             =   420
         Width           =   735
      End
   End
   Begin VB.Label LblResetStatus 
      Alignment       =   2  'Center
      BorderStyle     =   1  'Fixed Single
      Height          =   255
      Left            =   180
      TabIndex        =   11
      Top             =   2760
      Width           =   1275
   End
End
Attribute VB_Name = "Frm2650"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Public MM          As Frm2601
Public MyIomPort   As Byte

Private Init        As Boolean
Private DemoClicked As Boolean

Public Sub FormReset()
    ' Set form controls to their Reset conditions.
    Dim Chan As Integer
    Init = True
    For Chan = 0 To 7
        ChkRlyCmd(Chan).Value = 0
        ChkRlyCmd(Chan).Enabled = True
    Next Chan
    DemoClicked = False
    BtnDemo.Enabled = True
    Init = False
End Sub

Private Sub BtnReset_Click()
    MM.Reset MyIomPort      ' Invoke module reset.
    FormReset               ' Set form controls to their Reset conditions.
End Sub

Private Sub BtnDemo_Click()
    Dim Chan As Integer
    DemoClicked = True
    BtnDemo.Enabled = False
    For Chan = 0 To 7
        ChkRlyCmd(Chan).Enabled = False
    Next Chan
End Sub

Private Sub SetDio(ByVal RelayData As Integer)
    Dim hTransact As Long
    hTransact = S26_SchedOpen(MM.MyHbd, DEFAULT_RETRIES)
    S26_Sched2650_SetOutputs hTransact, MyIomPort, (RelayData And &HFF)
    MM.SchedExecute hTransact
End Sub

Private Sub ChkRlyCmd_Click(Index As Integer)
    ' Set relay output state.
    Dim Chan As Integer
    Dim RlyData As Integer
    If (Not Init) And (Not DemoClicked) Then
        ' Compute relay states byte value.
        For Chan = 0 To 7
            RlyData = RlyData + ((ChkRlyCmd(Chan).Value <> 0) And (2 ^ Chan))
        Next Chan
        ' Invoke physical relay state changes.
        SetDio RlyData
    End If
End Sub

Private Function DemoData()
    Const NUM_SHIFTS = 10
    Const NUM_COUNTS = 1
    Const NUM_TOGGLES = 10
    Const TOG_BITMASK = &H8
    
    Static mode     As Integer
    Static Counts   As Integer
    Dim DemoVal  As Integer
    
    Select Case mode
        Case 0:     ' SHIFT REG
            DemoVal = 2 ^ (Counts And 7)
            Counts = Counts + 1
            If (Counts >= (NUM_SHIFTS * 8)) Then
                mode = mode + 1
                Counts = 0
            End If
        Case 1:     ' COUNT UP
            DemoVal = Counts
            Counts = Counts + 1
            If (Counts >= ((NUM_COUNTS * 256) - 1)) Then
                mode = mode + 1
                Counts = 0
            End If
        Case 2:     ' TOGGLES
            DemoVal = IIf(Counts And TOG_BITMASK, 255, 0)
            Counts = Counts + 1
            If (Counts >= (2 * (NUM_TOGGLES * TOG_BITMASK))) Then
                mode = 0
                Counts = 0
            End If
    End Select
    
    DemoData = DemoVal
End Function

Public Sub SweepAll()
    If DemoClicked Then SetDio DemoData()
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    Cancel = (UnloadMode = vbFormControlMenu)
    If Cancel Then
        MM.TogIomVisible (MyIomPort)
    End If
End Sub

Private Sub LblResetStatus_Click()
    MM.ResetIomStatusFlags MyIomPort, STATUS_RST
End Sub
